<script setup lang="ts">
import { ref } from 'vue'
import { useCheckInOutStore } from '@/stores/CheckInOut'
import type { CheckDate, CheckUser } from '@/types/CheckInOut/CheckInOutDate'

const checkInOutStore = useCheckInOutStore()

const checkDateheaders = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Date (MM/DD/YYYY)',
    key: 'date',
    value: 'date'
  }
]
const checkUserheaders = [
  {
    title: 'User ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Time In',
    key: 'timeIn',
    value: 'timeIn'
  },
  {
    title: 'Time Out',
    key: 'timeOut',
    value: 'timeOut'
  },
  {
    title: 'Total Hour (HH:MM)',
    key: 'totalHour',
    value: 'totalHour'
  }
]

const formatDate = (date: Date) => new Date(date).toLocaleDateString()
const editedItem = ref<CheckDate>()
const send = (item: CheckDate) => (editedItem.value = item)
const calTotalHour = (timeIn: string, timeOut: string) => {
  return checkInOutStore.formatMinutesToHHMM(checkInOutStore.calculateTotalMinutes(timeIn, timeOut))
}
</script>

<template>
  <v-sheet>
    <v-row>
      <!-- First Table -->
      <v-col cols="4">
        <v-card variant="outlined" color="primary">
          <v-card-title>Date</v-card-title>
          <v-data-table
            :items="checkInOutStore.checkDates"
            :headers="checkDateheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="300px"
          >
            <template v-slot:item="props">
              <tr @click="send(props.item)">
                <td>{{ props.item.id }}</td>
                <td>{{ formatDate(props.item.date) }}</td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>

      <!-- Second Table -->
      <v-col cols="8">
        <v-card variant="outlined" color="primary">
          <v-card-title>Date Detail</v-card-title>
          <v-data-table
            :items="editedItem?.checkUser"
            :headers="checkUserheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="300px"
          >
            <template v-slot:item="props">
              <tr>
                <td>{{ props.item.id }}</td>
                <td>{{ props.item.name }}</td>
                <td>{{ checkInOutStore.formatTime(props.item.timeIn) }}</td>
                <td>{{ checkInOutStore.formatTime(props.item.timeOut) }}</td>
                <td>{{ calTotalHour(props.item.timeIn, props.item.timeOut) }}</td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>
    </v-row>
  </v-sheet>
</template>

<style scoped>
.flex-grow-1 {
  flex-grow: 1;
}
</style>

<style scoped></style>
